;====================================================================
; By L.Nemirovsky...............................................1997
; Better Than Nothing Software Version 1.1
; WBA.LSP - WBLOCK all internal blocks to the user specified 
; directory and create a list of all internal blocks................
; UPDA.LSP - Run this program to update all blocks in the drawing...
; WBS.LSP - let you start blocks from the list creted by WBA.LSP
;====================================================================

(defun c:wba (/ dir pref name1 lpref lname bl bln dist star fa masege
                env dialog  ddr)
(setvar "cmdecho" 0)
(setq dir "")
(setq dialog "wba.dcl")
(setq ddr (getvar "dwgprefix"))
;.....................................................................

(setq dat (load_dialog dialog))
(if (not (new_dialog "wba" dat)) (exit))

(set_tile "but" ddr)
(mode_tile "but" 2)
(action_tile "but" "(setq dir $value)")
(action_tile "cancel" "(exit)")

(start_dialog)
(unload_dialog dat)

;....................................................................

(if (= dir "")(exit))
(setq pref (getvar "dwgprefix"))
(setq name1 (getvar "dwgname"))
(setq lpref (+ 1 (strlen pref)))
(setq lname (strlen name1))
(if 
 (> lname 8)
 (setq name (substr name1 lpref))
 (setq name name1)
)
(setq file (strcat dir name ".txt"))  

  (setq bl (tblnext "block" T))
  (setq bln (cdr (assoc 2 bl)))
  (setq dist (strcat dir bln))
  (setq star (substr bln 1 1))
   (if (/= star "*")
      (progn 
       (command "wblock" dist "Y" bln)
       (setq fa (open file "w"))
       (write-line bln fa)
       (close fa)
      )
   )

   (while
    (setq bl (tblnext "block"))
    (setq bln (cdr (assoc 2 bl)))
    (setq dist (strcat dir bln))
    (setq star (substr bln 1 1))
      (if (/= star "*")
        (progn 
         (command "wblock" dist "Y" bln)
         (setq fa (open file "a"))
         (write-line bln fa)
         (close fa)
        )
      )
   )
(setq mesage (strcat "Internal blocks are written to " dir " directory
as External Blocks. 
List of blocks stored in " file)) 
(alert mesage)
(princ)
)
;=====================================================================

(defun c:upda (/ dir pref name1 lpref lname file line fr blname upd
                 env dialog ddr)
(setvar "regenmode" 0)
(setq dir "")
(setq env (getenv "user"))
(setq dialog "wba.dcl")
(setq ddr "c:\\")

;....................................................................

(setq dat (load_dialog dialog))
(if (not (new_dialog "wba" dat)) (exit))

(set_tile "but" ddr)
(mode_tile "but" 2)
(action_tile "but" "(setq dir $value)")
(action_tile "cancel" "(exit)")

(start_dialog)
(unload_dialog dat)

;....................................................................

(if (= dir "")(exit))
(setq pref (getvar "dwgprefix"))
(setq name1 (getvar "dwgname"))
(setq lpref (+ 1 (strlen pref)))
(setq lname (strlen name1))
(if 
 (> lname 8)
 (setq name (substr name1 lpref))
 (setq name name1)
)

(setq file (strcat dir name ".txt"))  

(setq fr (open file "r"))
    (while  
      (setq line (read-line fr))
      (setq blname (strcat dir line))
      (setq upd (strcat line "=" blname))
       (if 
        (/= upd nil)
        (command "insert" upd nil)
       )
    )  
(close fr)
(command "regen")
(princ)
)
;.....................................................................


;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
(prompt "\nProgram WBA.LSP Version 1.1 is loaded. BTN
At command prompt type: WBA, UPDA or WBS")
(PRINC)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
