;This function will change an arc to a circle
;written by: S. Restmeyer 6/2/98
;;;
;;;----------------------ERROR FUNCTION----------------------------
;;;
(DEFUN ERR (S);if an error (such as CTRL-C)
   ;occurs while this command is active...
   (if (not (member s '("console break" "Function cancelled")))
      (princ (strcat "\nError: " s))
   )
   (command "_.UNDO" "_E")     ;end any outstanding UNDO group
   (setvar "clayer" lr)
   (setvar "celtype" cel)
   (setvar "celtscale" clts)
   (setvar "cecolor" cec)
   (setvar "cmdecho" cmd)      ;restore saved mode
   (setq *error* olderr)
   (princ)
)
;;;---------------------- MAIN PROGRAM ----------------------------
;;;
(defun c:A2C (/ cmd sset sslen num ipt rad lr clyr temp cel cec ans lts clts)
   (setq olderr *error* *error* err)
   (setq lr (getvar "clayer"))
   (setq cel (getvar "celtype"))
   (setq clts (getvar "celtscale"))
   (setq cec (getvar "cecolor"))
   (SETQ CMD (GETVAR "CMDECHO"))
   (setvar "CMDECHO" 0)
   (command "_.UNDO" "_G")
   (prompt "\nSelect ARC\(S\) to be changed  ") (terpri)
 (if (not (null  (setq sset (ssget '((0 . "ARC"))))))
 (progn
   (setq sslen (sslength sset))
   (setq num 0)
   (repeat sslen
      (setq ent (entget (ssname sset num)))
      (setq temp (cdar ent))
      (setq clyr (cdr (assoc 8 ent))) 
      (setq ipt (cdr (assoc 10 ent)))
      (setq rad (cdr (assoc 40 ent)))
      (setq ans (cdr (assoc 6 ent)))
      (cond
         ((not (null ans)) 
            (setvar "celtype" ans)
         )
      )
      (setq ans (cdr (assoc 62 ent)))
      (cond
         ((not (null ans))  
            (setvar "cecolor" (rtos ans 2 0))
         )
      )
      (setq ans (cdr (assoc 48 ent)))
      (cond
         ((not (null ans))  
            (setvar "celtscale" ans)
         )
      )
      (setvar "clayer" clyr)
      (command "circle" ipt rad)
      (setvar "celtype" cel)
      (setvar "celtscale" clts)
      (setvar "cecolor" cec)
      (entdel temp)
      (setq num (+ num 1))
   )
   (princ (strcat (rtos num 2 0) " ARC\(S\) changed to CIRCLE\(S\). "))
)
(prompt "\nNo ARCS selected")
)
   (setvar "clayer" lr)
   (setvar "celtype" cel)
   (setvar "celtscale" clts)
   (setvar "cecolor" cec)
   (setvar "cmdecho" cmd)
   (setq *error* olderr)
   (princ)
)