//   Flange Dialog Control Language File
//   for Tols.lsp
//   Peter Best   19/03/99

tols : dialog {
             label = "  .  ";
          : row {
             :text {
              label = "";
              }
              spacer_1;
             :text {
              label = "       ";
              }
              spacer_1;
             :text {
              label = "    ";
              }
              }
          : row {
             fixed_width = true;
          : popup_list{
              key = "dia";
              list = "0 to 3\nover 3 to 6\nover 6 to 10\nover 10 to 14\nover 14 to 18"
                     "\nover 18 to 24\nover 24 to 30\nover 30 to 40\nover 40 to 50"
                     "\nover 50 to 65\nover 65 to 80\nover 80 to 100\nover 100 to 120"
                     "\nover 120 to 140\nover 140 to 160\nover 160 to 180\nover 180 to 200"
                     "\nover 200 to 225\nover 225 to 250\nover 250 to 280\nover 280 to 315"
                     "\nover 315 to 335\nover 335 to 400\nover 400 to 450\nover 450 to 500";
              edit_width = 14;
                   value = 0;
              }
          : popup_list{
              key = "shaft1";
              list = "a\nb\nc\nd\ne\nf\ng\nh\njs\nj\nk\nm\nn"
                     "\np\nr\ns\nt\nu\nv\nx\ny\nz";
              edit_width = 3;
                   value = 7;
              }
          : popup_list{
              key = "shaft2";
              list = "1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14\n15\n16";
              edit_width = 4;
                   value = 5;
              }
         : popup_list{
              key = "hole";
              list = "H6\nH7\nH8\nH9\nH10\nH11";
              edit_width = 5;
                 value = 1;
            }
            }// end of row
         : boxed_column {
           label = "";
            :column {
              fixed_width = true ;
            :row {
            :text {
              label = "   ";
              }
            :text {
              key = "uht";
              width = 10;
              }
              }// end of row
            :row {
            :text {
              label = "   ";
              }
            :text {
              key = "lht";
              width = 10;
              }
              }// end of row
            :row {
            :text {
              label = "            ";
              }
            :text {
              key = "ust";
              width = 10;
              }
              }// end of row
            :row {
            :text {
              label = "            ";
              }
            :text {
              key = "lst";
              width = 10;
              }
              }// end of row
              }// end of column
            :row {
            :text {
              label = " :  ";
              }
            :text {
              key = "typefit";
              width = 20;
              }
              }// end of row
            :row {
            :text {
              label = ":";
              }
            :text {
              key = "prefit";
              width = 20;
              }
              }// end of row
            }// end of boxed column
         : boxed_column {
              label = " ";
            :column {
              fixed_width = true ;
            :row {
            :text {
              label = "";
              }
            :text {
              key = "cmax";
              width = 20;
              }
              }// end of row
            :row {
            :text {
              label = " ";
              }
            :text {
              key = "cmin";
              width = 20;
              }
              }// end of row
              }// end of column
              }// end of boxed column

            : row {
            : button {
              label = "  " ;
              key = "shaftnotes";
              is_default = true ;
              is_cancel = true ;
            }
            : button {          // "OK" button renamed
              label = "  ";
              key = "holenotes";
              is_default = true ;
              is_cancel = true ;
            }
            }// end of row
            :row {
            : image {
                   key = "im" ;
                   height = 1.0 ;
                   width = 3.7 ;
              fixed_width = true ;
                   }
            : button {
              label = "" ;
              key = "info";
              is_default = true ;
              fixed_width = true ;
              is_cancel = true ;
                 }
            : retirement_button {
                label = "Exit";
                key = "exit";
                is_cancel = true;
              fixed_width = true;
              }
           }// end of row
           }// end of dialog

 info : dialog {
   label = "" ;
   : list_box {
      width = 50 ;
        list ="\nDescription of preferred fits"
      "\nH11/c11"
      "\n\"Loose running\" fit for wide commercial tolerances or"
      "\n  allowances on external members."
      "\nH9/d9"
      "\n\"Free running\" fit not for use where accuracy is essential,"
      "\n  but good for large temperature variations, high running"
      "\n  speeds, or heavy journal pressures."
      "\nH8/f7"
      "\n\"Close running\" fit for running on accurate machines and"
      "\n  for accurate location at moderate speeds and journal"
      "\n  pressures."
      "\nH7/g6"
      "\n\"Sliding fit\" not intended to run freely, but to move and"
      "\n  turn freely and locate accurately."
      "\nH7/h6"
      "\n\"Locational clearance\" fit provides snug fit for locating"
      "\n  stationary parts; but can be freely assembled and"
      "\n  disassembled."
      "\nH7/k6"
      "\n\"Locational transition\" fit for accurate location, a"
      "\n  compromise between clearance and interference."
      "\nH7/n6"
      "\n\"Locational transition\" fit for more accurate location"
      "\n  where greater interference is permissible."
      "\nH7/p6"
      "\n\"Locational interference\" fit for parts requiring rigidity"
      "\n  and alignment with prime accuracy of location but without"
      "\n  special bore pressure requirements."
      "\nH7/s6"
      "\n\"Medium drive\" fit for ordinary steel parts or shrink fits"
      "\n  on light sections, the tightest fit usable with cast iron."
      "\nH7/u6"
      "\n\"Force\" fit suitable for parts which can be highly stressed"
      "\n  or for shrink fits where the heavy pressing forces required"
      "\n  are impractical."
      "\n "
      "\n(Extracts from Machinery Handbook)"
      "\n "
      "\n                        Peter Best   March 1999            ";
   }              // end of list box
    :  button {
       label = "OK" ;
       is_default = true ;
       fixed_width = true ;
       is_cancel = true ;
       alignment = centered;
   }
   }            // end of dialog
