;;; For AutoCAd r14 /Windows 95/
;;;  by Genchik P
;;;_____________________________________________________________
;  USe _otvod.dwg
;;;_____________________________________________________________
; Lisp file _OTVOD.LSP    by Pospelov G.E.
;__________________________ OTVOD ____________________
;
;********        
;      -  .
;
;     :
; -r    -     
; -d    -  
; -n1   --   <16>
; -alfa -  /-,     
;    /         alfa=a*(n+1);  a=alfa/(n+1);
; -n    -  
; po   n+1   p    alfa
;p pp p
; -y    -   x
; -x    -   
; -c    - 
;
;    OTVOD.DWG   
;      ,   
; .
;
;
;************************************************************
;
;____________________________________________________________
;ERROR FUNCTION
;(defun *error*(msg)
; (setq msg "Function Aborting by User")
; (princ)
; (princ msg)
; (princ)
;)
;___________________________________________________________
;
;___________________________________________________________________
;    
(defun MODES (a)
   (setq MLST '())
   (repeat (length a)
      (setq MLST (append MLST (list (list (car a) (getvar (car a))))))
      (setq a (cdr a)))
)
;___________________________________________________________________
;    
(defun MODER ()
   (repeat (length MLST)
      (setvar (caar MLST) (cadar MLST))
      (setq MLST (cdr MLST))
   )
 (setq MLST nil)
)
;___________________________________________________________
;********* CALC
(defun calcy (ci ca cr cd cn1 / cy al)
 (setq  ca (/ ca 2.0)
        al (/ (* 3.1416 ci) cn1)
 cy (* 2.0 (/ (sin ca)(cos ca)) (+(- cr (/ cd 2.0))(* cd (sin al) (sin al))) 
          )
  ) ;close setq
)
;
;___________________________________________________________

;____________________________________________________________
;********* MAIN FUNCTION ************************************
;------------------------------------------------------------
;
(defun C:otvod ( / r d n1 alfa y x c i pt pti) 
 (modes '("BLIPMODE" "CMDECHO"))
 (setvar "CMDECHO" 0)
 (setvar "BLIPMODE" 0)
 (setq
      pi  3.1416
      r    (getdist "\n    : ")
      alfa (getdist "  : ")
      d    (getdist " : ")
      n1    16     
;      n1   (getint "-    <10...20>: ")
      n    (getint "- : ")
      alfa (abs(/ (- 180.0 alfa) (+ n 1.0) ) )
      alfa (/ (* pi alfa) 180.0)
      c    (* pi d)
      x    (/ c n1)
      pt   (getpoint"\n   : ")
      i    0.0
  )
(setq pti (list (car pt) (cadr pt)))

 (while (<= i (/ n1 2)) (progn
                (setq y (rtos(calcy i alfa r d n1) 2 1))
                (command "TEXT" pt 4 0 y)
                (setq i (1+ i))
                (setq pt (list (car pt) (- (cadr pt) 10.0)))
              )
 )
 (setq c (rtos c 2 1)
       x (rtos x 2 1))
 (command "INSERT" "_OTVOD.DWG" pti 1.0 1.0 0.0)
 (setq pt (list (car pt) (- (cadr pt) 30.0)))
 (command "TEXT" pt 4 0 c)
 (setq pt (list (car pt) (- (cadr pt) 10.0)))
 (command "TEXT" pt 4 0 x)

(moder)
) ;end function
***********************************************************
