;---------------------------------------------------------------------------
;---------- BALL.LSP    by Pospelov G.
;
;------------   AutoCAD 2000  BALL.LSP -----------------------------
;          
;  ,       
;  .   DIMASZ  ,
;    .      
;  ,      
;   .
;   <RETURN>       
; " :"      .
;---------------------------------------------------------------------------
;error function
(defun *error* (msg)
(setq msg "Function Abort itself")
(princ)
(princ msg)
(princ)
)
;
;---------------------------------------------------------------------------
;------------------> BALL <-------------------------------------------------
(defun c:ball ( tipus / a b c d h l r txt ce bm osm)

; 	 a :   
; 	 b :  
;	 c :    /  
;	 d :   /  
;	 h :  
;	 r :  

;       
  (setq ce (getvar "CMDECHO" )
        bm (getvar "BLIPMODE")
       osm (getvar "OSMODE")
  )
  (setq a T )
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (if (= tipus 0) (setvar "OSMODE" 0)
                  (setvar "OSMODE" 512)
  )  

;  -       
  (setq ts (cdr (assoc 40 (tblsearch "STYLE" (getvar "TEXTSTYLE")))))
  (if (zerop ts)

;      
      (setq r (* (getvar "DIMSCALE") (getvar "DIMTXT") 1.5)
            h (* (getvar "DIMSCALE") (getvar "DIMTXT"))
      )

;      
      (setq r (* ts 1.5))
      )

;   
;   / H  <RETURN>   
;                                               /
 (setq a (getpoint "\n  : ")) 
 (while a
    ;    (   )
       (initget 1)
       (setq b (getpoint a "\n  :  "))
       (if (null oldtxt) (setq oldtxt "n.1"))
       (prompt (strcat "\n <" oldtxt ">: "))
       (setq txt (getstring))
       (if (= txt "") (setq txt oldtxt))

;     (setvar "BLIPMODE" 0)
;  ,   DIMASZ   
      (if (= tipus 0)
         (progn
;     0.025  
;       
          (setq d (* (getvar "DIMSCALE") (getvar "DIMASZ") 0.025))
          (if (> d 0) (command "CIRCLE" a d ))
          )
         (progn
;     
           (setq c (polar a (+ (angle a b) 0.2)
                           (* (getvar "DIMSCALE") (getvar "DIMASZ") )
                  )
                d (polar a (- (angle a b) 0.2)
                           (* (getvar "DIMSCALE") (getvar "DIMASZ") )
                  )
           )
           (command "SOLID" a c d c "")
         )
      ) ; Close  if (= tipus 0)
;      
      (setq c (polar a
                      (angle a b)
                      (- (distance a b) r)
               )
       )
       (command "line" a c "") ;    
       (command "circle" b r) ;    

;     ( ,  
;     )
       (if (zerop ts)
           (command "TEXT" "M" b h 0 txt)
           (command "TEXT" "M" b pause 0 txt)
       )
     (setq oldtxt (itoa (1+ (atoi txt)))
            a T )

     (setq a (getpoint "\n  <Enter - >: "))
   
 )  ;close while

;    
 (setvar "BLIPMODE" bm)
 (setvar "CMDECHO" ce)
 (setvar "OSMODE" osm)
 (princ)
)
;;;-------------------------------------------------------------------