;;------------------------------------------------------------------------
;;  Adding PG for AutoCAD r14 12/08/97
;;  03/05/99  AutoCAD r15 (2000)
;;  03.05.99
;;      
;;           N02
;;       FACING.DCL
;;                                FACing.SLB
;;
;;
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;
;;------------------------------------------------------------------------
;;------> error function <------------------------------------------------
(defun *error* (msg)
  (setq msg "Function Abort now")
  (print)
  (princ msg)
  (print)
)
;;------------------------------------------------------------------------
;;-----------> help about programm <--------------------------------------
;;------------------------------------------------------------------------
(defun ab_prog (ab_progr)
 
 (if (not (new_dialog "ab_text" DCL_ID)) (exit))
 (start_list "ab_progr")
 (mapcar 'add_list ab_progr)
 (end_list)

 ;(action_tile "ab_progr" "")
 (action_tile  "accept" "(done_dialog)")
 (start_dialog)
)

;-------------------------------------------------------------------------
;-------------> SHR - working prog<---------------------------------------
				
(defun shr (chislo typ / pt1 pt2 pt3 pt4 escho cmd1 blm)
  (initget (+ 1 2))
  (setq pt1 (getpoint "\n : "))

;;;________________>  <_________________________
  (if (not (eq typ "rbok"))
    (progn
      (if (or (= typ "Up")
	      (= typ NIL)
	  )
	(progn
	  (setq	pt2 (list (- (car pt1) 2.5) (+ (cadr pt1) 5))
		pt3 (list (+ (car pt1) 5) (+ (cadr pt1) 10))
	  )
	  (if (or (eq chislo "00") (eq chislo "0"))
	    (progn
	      (setq pt4 (list (car pt1) (- (cadr pt2) 1)))
	      (command "circle" pt4 1.6)
	    )
	    (command "text"
		     "r"
		     (list (+ (car pt2) 3) (+ (cadr pt2) 2))
		     3.5
		     0
		     chislo
	    )
	  )
	)
      )
      (if (eq typ "Down")
	(progn
	  (setq	pt2 (list (+ (car pt1) 2.5) (- (cadr pt1) 5))
		pt3 (list (- (car pt1) 5) (- (cadr pt1) 10))
	  )
	  (if (or (eq chislo "00") (eq chislo "0"))
	    (progn
	      (setq pt4 (list (car pt1) (+ (cadr pt2) 1)))
	      (command "circle" pt4 1.6)
	    )
	    (command "text"
		     (list (- (car pt2) 4) (- (cadr pt2) 6))
		     3.5
		     0
		     chislo
	    )
	  )
	)
      )
      (if (eq typ "Left")
	(progn
	  (setq	pt2 (list (- (car pt1) 5) (- (cadr pt1) 2.5))
		pt3 (list (- (car pt1) 10) (+ (cadr pt1) 5))
	  )
	  (if (or (eq chislo "00") (eq chislo "0"))
	    (progn
	      (setq pt4 (list (+ (car pt2) 1) (cadr pt1)))
	      (command "circle" pt4 1.6)
	    )
	    (command "text"
		     "r"
		     (list (- (car pt2) 2) (+ (cadr pt2) 3))
		     3.5
		     90
		     chislo
	    )
	  )
	)
      )
      (if (eq typ "Right")
	(progn
	  (setq	pt2 (list (+ (car pt1) 5) (+ (cadr pt1) 2.5))
		pt3 (list (+ (car pt1) 10) (- (cadr pt1) 5))
	  )
	  (if (or (eq chislo "00") (eq chislo "0"))
	    (progn
	      (setq pt4 (list (- (car pt2) 1) (cadr pt1)))
	      (command "circle" pt4 1.6)
	    )
	    (command "text"
		     (list (+ (car pt2) 6) (- (cadr pt2) 4))
		     3.5
		     90
		     chislo
	    )
	  )
	)
      )
      (command "pline" pt2 "w" 0.0 0.0 pt1 pt3 "")
      (initget "Yes No")
      (if (or
	   (= (setq typ (getkword "\n  (Y/N)<N>:")) "No")
           (= typ NIL)
	  )
	(setq typ nil)
	(command "circle" pt3 1.6)
      )
    )
;;;;_____________> close progn if-rbok <______
;;;__________________>  if-rbok  nill      <______
    (progn
      (setvar "OSMODE" 0)
      (setq pt2	(list (- (car pt1) 2.5) (+ (cadr pt1) 5))
	    pt3	(list (+ (car pt1) 5) (+ (cadr pt1) 10))
      )
      (if (or (eq chislo "00") (eq chislo "0"))
	(progn
	  (setq pt4 (list (car pt1) (- (cadr pt2) 1)))
	  (command "circle" pt4 1.6)
	)
	(command "text"
		 "r"
		 (list (+ (car pt2) 3) (+ (cadr pt2) 2))
		 3.5
		 0
		 chislo
	)
      )
      (command "pline" pt2 "w" 0.0 0.0 pt1 pt3 "")
      (setq pt1	(list (+ (car pt1) 10) (cadr pt1))
	    pt2	(list (- (car pt1) 2.0) (+ (cadr pt1) 4))
	    pt3	(list (+ (car pt1) 4) (+ (cadr pt1) 8))
      )
      (setq pt4 (list (+ (car pt1) 1.5) (cadr pt2)))
      (command "line" pt2 pt1 pt3 "")
      (command "arc"
	       "c"
	       pt4
	       (list (car pt2) (+ (cadr pt2) 4.7))
	       "a"
	       110
      )
      (command "arc"
	       "c"
	       pt4
	       (list (+ (car pt4) 3) (- (cadr pt2) 5))
	       "a"
	       110
      )
    )
  )					; close if-rbok
)
;;;;   CLOSE FUNCTION
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;;*************>  BAD_SEL    <******************************
(defun bad_sel (t / soob)
  (cond	((= t 1) (setq soob " ERROR     "))
	((= t 2) (setq soob " ERROR     "))
  )
  (print soob)
  (exit)
)
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(defun im_q1 (f_color /)
  (setq	x2 (dimx_tile "q1")
	y2 (dimy_tile "q1")
  )
  (start_image "q1")
  (fill_image 0 0 x2 y2 f_color)
  (slide_image 0 0 x2 y2 "facing(up)")
  (end_image)
)
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(defun im_q2 (f_color /)
  (setq	x2 (dimx_tile "q2")
	y2 (dimy_tile "q2")
  )
  (start_image "q2")
  (fill_image 0 0 x2 y2 f_color)
  (slide_image 0 0 x2 y2 "facing(left)")
  (end_image)
)
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(defun im_q3 (f_color /)
  (setq	x2 (dimx_tile "q3")
	y2 (dimy_tile "q3")
  )
  (start_image "q3")
  (fill_image 0 0 x2 y2 f_color)
  (slide_image 0 0 x2 y2 "facing(right)")
  (end_image)
)
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(defun im_q4 (f_color /)
  (setq	x2 (dimx_tile "q4")
	y2 (dimy_tile "q4")
  )
  (start_image "q4")
  (fill_image 0 0 x2 y2 f_color)
  (slide_image 0 0 x2 y2 "facing(down)")
  (end_image)
)
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
(defun im_q5 (f_color /)
  (setq	x2 (dimx_tile "q5")
	y2 (dimy_tile "q5")
  )
  (start_image "q5")
  (fill_image 0 0 x2 y2 f_color)
  (slide_image 0 0 x2 y2 "facing(rbok)")
  (end_image)
)
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

(defun c:facing	(/ $key	tt in_det  cmd1 blm old_snap	old_aper help_pr)

  (setq	cmd1	 (getvar "CMDECHO")
	blm	 (getvar "BLIPMODE")
	old_snap (getvar "OSMODE")
	old_aper (getvar "APERTURE")
	help_pr	 (list
		   "                                   "
		   " "
		   "     ,   "
		   "    Rz  Ra, "
		   "    (  "
		   "       -    "
		   "   ) " " "
		   " Copyright  SingleSoft PG  " " ")
	info_pr	 (list
		   "          "
		   " "
		   "     facing.slb "
		   " "
		   "        Copyright  \"SingleSoft PG\"  "
		   "                   mailto:gepos@mail.ru "
		   " "
		  )
  )

  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (setvar "OSMODE" 512)
  (setvar "APERTURE" 3)

  (setq DCL_ID (load_dialog "facing.dcl"))

  (if (not (new_dialog "face_1" DCL_ID))
    (exit)
  )
  (im_q1 -15)
  (im_q2 -15)
  (im_q3 -15)
  (im_q4 -15)
  (im_q5 -15)

  (action_tile
    "q1"
    "(progn (im_q1 141)(im_q2 -15)(im_q3 -15)(im_q4 -15)
                           (im_q5 -15)(setq in_det  \"Up\") )"
  )
  (action_tile
    "q2"
    "(progn (im_q2 141)(im_q1 -15)(im_q3 -15)(im_q4 -15)
                           (im_q5 -15)(setq in_det  \"Left\") )"
  )
  (action_tile
    "q3"
    "(progn (im_q3 141)(im_q1 -15)(im_q2 -15)(im_q4 -15)
                           (im_q5 -15)(setq in_det  \"Right\") )"
  )
  (action_tile
    "q4"
    "(progn (im_q4 141)(im_q1 -15)(im_q2 -15)(im_q3 -15)
                           (im_q5 -15)(setq in_det  \"Down\") )"
  )
  (action_tile
    "q5"
    "(progn (im_q5 141)(im_q1 -15)(im_q2 -15)(im_q3 -15)
                           (im_q4 -15)(setq in_det  \"rbok\") )"
  )
  (action_tile "00" "(setq tt $key )")
  (action_tile "Rz40" "(setq tt $key )")
  (action_tile "Rz20" "(setq tt $key )")
  (action_tile "25" "(setq tt \"2,5\" )")
  (action_tile "125" "(setq tt \"1,25\")")
  (action_tile "63" "(setq tt \"0,63\")")

  (action_tile "A500" "(setq tt \"50\")")
  (action_tile "A250" "(setq tt \"25\")")
  (action_tile "A125" "(setq tt \"12,5\")")
  (action_tile "A63" "(setq tt \"6,3\")")
  (action_tile "A32" "(setq tt \"3,2\")")
  (action_tile "A16" "(setq tt \"1,6\")")
  (action_tile "A08" "(setq tt \"0,8\")")
  (action_tile "A04" "(setq tt \"0,4\")")

  (action_tile "help" "(ab_prog help_pr)")
  (action_tile "info" "(ab_prog info_pr)")
  (action_tile "Ok" "(done_dialog 1)")
  (action_tile "cancel" "(done_dialog 0)")
  (if (= 1 (start_dialog))
    (progn
      (if (= tt nil) (bad_sel 2)       )
      (if (= in_det nil) (bad_sel 1)   )
      (shr tt in_det)
    )
  )
  ;; close IF &  Progn
  (unload_dialog DCL_ID)

  (setvar "OSMODE" old_snap)
  (setvar "APERTURE" old_aper)
  (setvar "CMDECHO" cmd1)
  (setvar "BLIPMODE" blm)
)
;;****************> END <********************************



