;;------------------------------------------------------------------------
;;  Adding PG for AutoCAD r14 12/08/97
;; 06/07/99  AutoCAD r15 (2000)
;; 
;;      
;;  
;;
;;
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
;error function
(defun *error* (msg)
(if (= msg "Function Abort by user")
(princ)
(princ msg)
)
(princ)
)
;----------------------------------------------------------
(defun c:svar( / p1 p2 p3 p4 p5 tt stext1 stext2 talf alfa cmd1 osm)

 (setq osm (getvar "OSMODE"))
 (setvar "OSMODE" 512)
 (initget 3)
 (setq p1 (getpoint "\n  : ")
      cmd1 (getvar "CMDECHO")
 )
 (setvar "CMDECHO" 0)
 ;(command "TEXT" "s" "txt" (command))
 (setvar "OSMODE" 0)
 (while p1
  (setq p2 (getpoint p1 "\n  : ")
        p3 (getpoint "\n  : ")
        tt (getstring T "\n : ")
     )
  (if (> (car p3) (car p2))
     (progn (setq p3 (list (+ (car p2) (+ (* (strlen tt) 3.5) 13)) (cadr p2))
                  p4 (list (+ (car p2) 6) (+ (cadr p2) 1.3))
                )
            (command "TEXT" p4 3.6 0 tt)
      )
     (progn (setq p3 (list (- (car p2) (+ (* (strlen tt) 3.5) 10)) (cadr p2))
                  p4 (list (+ (car p3) 2) (+ (cadr p3) 1.3))
                )
            (command "TEXT" p4 3.6 0 tt)
   ))  ; if and progn2
  (setq  alfa (atan (- (cadr p2) (cadr p1)) (- (car p2) (car p1)))
         p4 (polar p1 alfa 6)
         talf (/ (* alfa 180) pi)
    )
  (setq dist (* (distance p2 p4) 0.5))
  (setq stext1 (getstring T"\n <2N3>: ")
        stext2 (getstring "\n   : ") )
  (if (< (car p2) (car p1))
     (progn (setq  p5 (polar p4 (- alfa (/ pi 2)) 1.7)
                    p6 (polar p5 alfa dist)
                    p7 (polar p6 (+ alfa (/ pi 2)) 7)
                 )
             (if (> dist 15) (progn
              (setq talf (+ 180 talf))
              (command "TEXT" p6 3.5 talf stext1)
              (command "TEXT" p7 3.5 talf stext2)
        )   ))
     (progn (setq  p5 (polar p4 (+ alfa (/ pi 2)) 1.7)
                    p6 (polar p5 alfa dist)
                    p7 (polar p6 (- alfa (/ pi 2)) 7)
                 )
             (if (> dist 15) (progn
              (command "TEXT" p6 3.5 talf stext1)
              (command "TEXT" p7 3.5 talf stext2)
       )     ))
    )  ;   if (< (car p2) (car p1)
  (command "LINE" p1 p2 p3 "")
  (command "CIRCLE" p2 1.6)
  (command "SOLID" p1 p4 p5 p4 "")
  (setvar "OSMODE" 512)
  (if (or
       (= (setq p1 (getpoint "\n : ")) "nil")
       (= p1 NIL))
     (setq p1 nil)
    )
 ) ;WHILE
(setvar "CMDECHO" cmd1)
(setvar "OSMODE" osm)
)
;;;------------------------------------------------------------------